package org.nwoca.ssdt.tools.html2wiki;

import java.util.regex.*;

class PreTagTransformer implements Transformer {
    private Pattern pattern = Pattern.compile("<pre>.*?</pre>",Pattern.MULTILINE + Pattern.DOTALL);
    public PreTagTransformer() {
         
    }
    
    public void apply(StringBuffer buffer) {
        Matcher matcher = pattern.matcher(buffer);
        
        boolean first = true;
        while (matcher.find( first ? 0 : matcher.end())) {
            String temp = buffer.substring(matcher.start(),matcher.end());
            temp = temp.replaceAll("(?m)^\\s","\r&nbsp;");
            buffer.replace(matcher.start(),matcher.end(),temp);
            first = false;
        }
     
    }
        
    public String toString() {
        return "Preserving <pre> tag spacing";
    }

}