package org.nwoca.ssdt.tools.html2wiki;

import java.util.regex.*;

class TagTransformer implements Transformer {
    private Pattern tagPattern;
    private String replacementBegin;
    private String replacementEnd;
    
    public TagTransformer(String regexp, String replacementBegin, String replacementEnd) {
        tagPattern = Pattern.compile(regexp);
        this.replacementBegin = replacementBegin;
        this.replacementEnd = replacementEnd;
         
    }
    public TagTransformer(String regexp, String replacement) {
        this(regexp,replacement,replacement);
    }
    
    public void apply(StringBuffer buffer) {
        Matcher matcher = tagPattern.matcher(buffer);
        
        boolean first = true;
        while (matcher.find(first ? 0 : matcher.start())) {
            buffer.replace(matcher.start(),matcher.end(),replacementBegin + matcher.group(1) + replacementEnd);
            first = false;
        }
     
    }
        
    public String toString() {
        return "Replace: " + tagPattern.pattern() + " with " +replacementBegin + "..." + replacementEnd;
    }

}